"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var axios_1 = __importDefault(require("axios"));
var prompts_1 = __importDefault(require("prompts"));
var middlewareUrl = 'http://localhost:5000';
var inputTweet = function () { return __awaiter(void 0, void 0, void 0, function () {
    var onCancel, input, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                onCancel = function () {
                    console.error('Error: 入力内容が確認できませんでした...もう一度最初から入力してください。');
                };
                return [4 /*yield*/, prompts_1["default"]([
                        {
                            type: 'text',
                            name: 'input',
                            message: 'ツイート: ',
                            validate: function (value) { return (!value ? '何か入力してください' : true); }
                        }
                    ], { onCancel: onCancel })];
            case 1:
                input = (_a.sent()).input;
                return [2 /*return*/, { input: input }];
            case 2:
                err_1 = _a.sent();
                return [2 /*return*/, { input: '' }];
            case 3: return [2 /*return*/];
        }
    });
}); };
var postTweet = function (accessToken, accessTokenSecret, tweet) { return __awaiter(void 0, void 0, void 0, function () {
    var res, err_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, axios_1["default"].post(middlewareUrl + "/postTweet", {
                        access_token: accessToken,
                        access_token_secret: accessTokenSecret,
                        tweet: tweet
                    })];
            case 1:
                res = _a.sent();
                console.log(res.data);
                return [2 /*return*/, true];
            case 2:
                err_2 = _a.sent();
                return [2 /*return*/, false];
            case 3: return [2 /*return*/];
        }
    });
}); };
var checkUser = function (db, tweet) {
    return db.find({}, // 最新の登録ユーザーを使うように一旦設定
    // { selected: true },
    function (err, result) { return __awaiter(void 0, void 0, void 0, function () {
        var _a, accessToken, accessTokenSecret;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!!err) return [3 /*break*/, 2];
                    _a = result.slice(-1)[0] // 変更
                    , accessToken = _a.accessToken, accessTokenSecret = _a.accessTokenSecret;
                    return [4 /*yield*/, postTweet(accessToken, accessTokenSecret, tweet)];
                case 1:
                    if (_b.sent()) {
                        console.log('Success: 送信完了');
                        return [2 /*return*/, true];
                    }
                    console.log('Error: トホホ...送信に失敗しちゃったようですね');
                    return [2 /*return*/, false];
                case 2:
                    console.log('Error: アカウントが見つからないようです...');
                    return [2 /*return*/, false];
            }
        });
    }); });
};
var Tweet = function (db, tweet) { return __awaiter(void 0, void 0, void 0, function () {
    var input;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!tweet) return [3 /*break*/, 2];
                return [4 /*yield*/, checkUser(db, tweet)];
            case 1:
                if (_a.sent()) {
                    return [2 /*return*/, true];
                }
                return [2 /*return*/, false];
            case 2: return [4 /*yield*/, inputTweet()];
            case 3:
                input = (_a.sent()).input;
                if (!input) return [3 /*break*/, 5];
                return [4 /*yield*/, checkUser(db, input)];
            case 4:
                if (_a.sent()) {
                    return [2 /*return*/, true];
                }
                return [2 /*return*/, false];
            case 5:
                console.log('Error: 不明なエラー');
                return [2 /*return*/, false];
        }
    });
}); };
exports["default"] = Tweet;
